#include "StdAfx.h"
#include "RheaGameServer.h"
#include <iostream>

using namespace std;

CRheaGameServer::CRheaGameServer(boost::asio::io_service& io_service,
	const tcp::endpoint& endpoint)
	: m_io_service_(io_service),
	m_acceptor_(io_service, endpoint)
{
	RheaGame_session_ptr new_session(new CRheaGameSession(m_io_service_, m_RheaServerWorld_));
	m_acceptor_.async_accept(new_session->socket(),
		boost::bind(&CRheaGameServer::handle_accept, this, new_session,
		boost::asio::placeholders::error));
}

void CRheaGameServer::handle_accept(RheaGame_session_ptr session,
	const boost::system::error_code& error)
{
	if (!error)
	{
		session->start();
		RheaGame_session_ptr new_session(new CRheaGameSession(m_io_service_, m_RheaServerWorld_));
		m_acceptor_.async_accept(new_session->socket(), boost::bind(&CRheaGameServer::handle_accept, this, new_session,	boost::asio::placeholders::error));		

		std::string remote_ip = session->socket().remote_endpoint().address().to_string();
		unsigned short remote_port = session->socket().remote_endpoint().port();
		cout << "Client connected : " << remote_ip.c_str() << " : " << remote_port << endl;

	}
}