#pragma once

#include "RheaServerParticipant.h"
#include "RheaServerWorld.h"

class CRheaGameSession : public CRheaServerParticipant, public boost::enable_shared_from_this<CRheaGameSession>
{
public:
	CRheaGameSession(boost::asio::io_service& io_service, CRheaServerWorld& rheaServerWorld)
		: m_socket_(io_service),
		m_RheaServerWorld_(rheaServerWorld)
	{
	}

	tcp::socket& socket()
	{
		return m_socket_;
	}

	void start();
	void deliver(const CDataMessage& msg);
	void handle_read_header(const boost::system::error_code& error);
	void handle_read_body(const boost::system::error_code& error);
	void handle_write(const boost::system::error_code& error);

private:
	tcp::socket m_socket_;
	CRheaServerWorld& m_RheaServerWorld_;
	CDataMessage m_read_msg_;
	DataMessageQueue m_write_msgs_;
};

typedef boost::shared_ptr<CRheaGameSession> RheaGame_session_ptr;
