// RheaServer.cpp : Defines the entry point for the console application.
//
#include "stdafx.h"
#include "RheaGameServer.h"
#include "RheaGameSession.h"
#include "RheaServerParticipant.h"
#include "RheaServerWorld.h"

using namespace std;

int _tmain(int argc, _TCHAR* argv[])
{
	TCHAR szPort[100];
	int i = GetPrivateProfileString(_T("RHEA_SERVER"), _T("PORT"), _T(""), szPort, sizeof(szPort), _T(".\\RheaServer.ini"));
	if(0 == i)
	{
		cout << "Server Config Error.";
		return 0;
	}

	try
	{
		boost::asio::io_service io_service;

		rheagame_server_list servers;

		tcp::endpoint endpoint(tcp::v4(), atoi(szPort));
		rheagame_server_ptr server(new CRheaGameServer(io_service, endpoint));
		servers.push_back(server);

		cout << "Rhea Server Port : " << szPort << endl << "Now Running!" << endl;
		io_service.run();
	}
	catch (std::exception& e)
	{
		std::cerr << "Exception: " << e.what() << "\n";
	}

	return 0;
}

